import { CountryCode, LanguageCode } from "@cryptexlabs/codex-data-model";
import { HostConfigInterface } from "./host-config.interface";
import { SwitchConfigInterface } from "./switch-config.interface";
import { KafkaConfigInterface } from "./kafka-config.interface";
import { JwtConfigInterface } from "./jwt-config.interface";
import { UrlInterface } from "./url.interface";
import { PingConfigInterface } from "./ping-config.interface";
import { ConsumerTypeEnum } from "./consumer-type.enum";
import { JsonSerializableInterface } from "../message";
export declare class DefaultConfig implements JsonSerializableInterface<any> {
    private readonly _clientId;
    private _appName;
    private _packageVersion;
    private _appPath;
    constructor(basePath: string, appPath: string, _clientId: string, fallbackEnvironment?: string);
    toJSON(): {
        fallbackLanguage: LanguageCode;
        fallbackCountry: CountryCode;
        appVersion: string;
        appName: string;
        clientId: string;
        apiVersion: string;
        appPrefix: string;
        docsPrefix: string;
        docsEnabled: boolean;
        docsPath: string;
        kafka: KafkaConfigInterface;
        environmentName: string;
        logLevels: string[];
        httpPort: number;
        metrics: SwitchConfigInterface & HostConfigInterface;
        jwt: JwtConfigInterface;
        healthzFilePath: string;
        elasticsearch: UrlInterface & PingConfigInterface;
        consumerType: ConsumerTypeEnum;
        gpuEnabled: boolean;
        dataDirectory: string;
    };
    protected setup(basePath: string, appPath: string, environment: string): void;
    get fallbackLanguage(): LanguageCode;
    get fallbackCountry(): CountryCode;
    get appVersion(): string;
    get appName(): string;
    get clientId(): string;
    get apiVersion(): string;
    get appPrefix(): string;
    get docsPrefix(): string;
    get docsEnabled(): boolean;
    get docsPath(): string;
    get kafka(): KafkaConfigInterface;
    get environmentName(): string;
    get logLevels(): string[];
    get httpPort(): number;
    get metrics(): SwitchConfigInterface & HostConfigInterface;
    get jwt(): JwtConfigInterface;
    get healthzFilePath(): string;
    get elasticsearch(): UrlInterface & PingConfigInterface;
    get consumerType(): ConsumerTypeEnum;
    get gpuEnabled(): boolean;
    get dataDirectory(): string;
}
